<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/DocBook/Syntax.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/DocBook/Syntax.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/DocBook/Syntax.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2007 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line9"></a><span class="lineno">  9</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax.html#escape">escape</a>(text):</span>
<a id="line11"></a><span class="lineno"> 11</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line">    <span class="py-keyword">for</span> p <span class="py-keyword">in</span> [(<span class="py-string">'&amp;'</span>, <span class="py-string">'&amp;amp;'</span>), (<span class="py-string">'&quot;'</span>, <span class="py-string">'&amp;quot;'</span>), (<span class="py-string">'&lt;'</span>, <span class="py-string">'&amp;lt;'</span>), (<span class="py-string">'&gt;'</span>, <span class="py-string">'&amp;gt;'</span>),]:</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line">        text = text.replace(*p)</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line">    <span class="py-keyword">return</span> text</span>
<a id="line15"></a><span class="lineno"> 15</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/Syntax.html">Syntax</a>(ASG.Visitor):</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Even though DocBook provides markup for some programming artifacts,</span></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-string">    it is incomplete, and the XSL stylesheets are buggy, resulting in</span></span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-string">    incorrect syntax. Thus, we use the 'synopsis' element, and attempt to</span></span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="py-string">    reproduce the original syntax with language-specific subclasses.&quot;&quot;&quot;</span></span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/Syntax.html#__init__">__init__</a>(self, output):</span>
<a id="line23"></a><span class="lineno"> 23</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">        self.output = output</span>
<a id="line25"></a><span class="lineno"> 25</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/Syntax.html#finish">finish</a>(self): <span class="py-keyword">pass</span></span>
<a id="line27"></a><span class="lineno"> 27</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/Syntax.html#typeid">typeid</a>(self, type):</span>
<a id="line29"></a><span class="lineno"> 29</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">        self._typeid = <span class="py-string">''</span></span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">        type.accept(self)</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">        <span class="py-keyword">return</span> self._typeid</span>
<a id="line33"></a><span class="lineno"> 33</span>
<a id="line34"></a><span class="lineno"> 34</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonSyntax.html">PythonSyntax</a>(Syntax):</span>
<a id="line36"></a><span class="lineno"> 36</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonSyntax.html#visit_function">visit_function</a>(self, node):</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">        text = escape(str(node.return_type))</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">        text += <span class="py-string">'%s(%s)\n'</span>%(escape(node.real_name[-1]),</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">                            <span class="py-string">', '</span>.join([self.visit_parameter(p)</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">                                       <span class="py-keyword">for</span> p <span class="py-keyword">in</span> node.parameters]))</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">        self.output.write(text)</span>
<a id="line43"></a><span class="lineno"> 43</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonSyntax.html#visit_parameter">visit_parameter</a>(self, parameter):</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">        text = str(parameter.name)</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">        <span class="py-keyword">if</span> parameter.value:</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">            text += <span class="py-string">' = %s'</span>%escape(parameter.value)</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">        <span class="py-keyword">return</span> text</span>
<a id="line49"></a><span class="lineno"> 49</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonSyntax.html#visit_variable">visit_variable</a>(self, variable):</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">        variable.vtype.accept(self)</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">        self.output.write(variable.name[-1])</span>
<a id="line53"></a><span class="lineno"> 53</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonSyntax.html#visit_const">visit_const</a>(self, const):</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">        const.ctype.accept(self)</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">        self.output.write(const.name[-1])</span>
<a id="line57"></a><span class="lineno"> 57</span>
<a id="line58"></a><span class="lineno"> 58</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonSummarySyntax.html">PythonSummarySyntax</a>(PythonSyntax):</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Generate DocBook Synopsis for Python declarations.&quot;&quot;&quot;</span></span>
<a id="line61"></a><span class="lineno"> 61</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonSummarySyntax.html#__init__">__init__</a>(self, output):</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">        super(PythonSummarySyntax, self).__init__(output)</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">        self.output.write(<span class="py-string">'&lt;synopsis&gt;'</span>)</span>
<a id="line65"></a><span class="lineno"> 65</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonSummarySyntax.html#finish">finish</a>(self):</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">        self.output.write(<span class="py-string">'&lt;/synopsis&gt;\n'</span>)</span>
<a id="line68"></a><span class="lineno"> 68</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonSummarySyntax.html#visit_group">visit_group</a>(self, node):</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> node.declarations:</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">            d.accept(self)</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonSummarySyntax.html#visit_module">visit_module</a>(self, module):</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">        self.output.write(<span class="py-string">'%s %s\n'</span>%(module.type, module.name[-1]))</span>
<a id="line74"></a><span class="lineno"> 74</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonSummarySyntax.html#visit_class">visit_class</a>(self, class_):</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">        self.output.write(<span class="py-string">'class %s\n'</span>%escape(class_.name[-1]))</span>
<a id="line77"></a><span class="lineno"> 77</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonSummarySyntax.html#visit_inheritance">visit_inheritance</a>(self, node): <span class="py-keyword">pass</span></span>
<a id="line79"></a><span class="lineno"> 79</span>
<a id="line80"></a><span class="lineno"> 80</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonDetailSyntax.html">PythonDetailSyntax</a>(PythonSyntax):</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Generate DocBook Synopsis for Python declarations.&quot;&quot;&quot;</span></span>
<a id="line83"></a><span class="lineno"> 83</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonDetailSyntax.html#__init__">__init__</a>(self, output):</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">        super(PythonDetailSyntax, self).__init__(output)</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        self.output.write(<span class="py-string">'&lt;synopsis&gt;'</span>)</span>
<a id="line87"></a><span class="lineno"> 87</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonDetailSyntax.html#finish">finish</a>(self):</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">        self.output.write(<span class="py-string">'&lt;/synopsis&gt;\n'</span>)</span>
<a id="line90"></a><span class="lineno"> 90</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonDetailSyntax.html#visit_group">visit_group</a>(self, node):</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> node.declarations:</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">            d.accept(self)</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonDetailSyntax.html#visit_module">visit_module</a>(self, module):</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">        self.output.write(<span class="py-string">'%s %s\n'</span>%(module.type, module.name[-1]))</span>
<a id="line96"></a><span class="lineno"> 96</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonDetailSyntax.html#visit_class">visit_class</a>(self, class_):</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">        self.output.write(<span class="py-string">'class %s\n'</span>%escape(class_.name[-1]))</span>
<a id="line99"></a><span class="lineno"> 99</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/PythonDetailSyntax.html#visit_inheritance">visit_inheritance</a>(self, node): <span class="py-keyword">pass</span></span>
<a id="line101"></a><span class="lineno">101</span>
<a id="line102"></a><span class="lineno">102</span>
<a id="line103"></a><span class="lineno">103</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html">CxxSyntax</a>(Syntax):</span>
<a id="line104"></a><span class="lineno">104</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html#visit_function">visit_function</a>(self, node):</span>
<a id="line106"></a><span class="lineno">106</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">        text = node.return_type <span class="py-keyword">and</span> self.typeid(node.return_type) <span class="py-keyword">or</span> <span class="py-string">''</span></span>
<a id="line108"></a><span class="lineno">108</span><span class="line">        text += <span class="py-string">' %s(%s);\n'</span>%(escape(node.real_name[-1]),</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">                              <span class="py-string">', '</span>.join([self.visit_parameter(p)</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">                                         <span class="py-keyword">for</span> p <span class="py-keyword">in</span> node.parameters]))</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">        self.output.write(text)</span>
<a id="line112"></a><span class="lineno">112</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html#visit_parameter">visit_parameter</a>(self, parameter):</span>
<a id="line114"></a><span class="lineno">114</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">        text = escape(str(parameter.type))</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">        <span class="py-keyword">if</span> parameter.name:</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">            text += <span class="py-string">' %s'</span>%parameter.name</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">        <span class="py-keyword">if</span> parameter.value:</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">            text += <span class="py-string">' = %s'</span>%escape(parameter.value)</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">        <span class="py-keyword">return</span> text</span>
<a id="line121"></a><span class="lineno">121</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html#visit_typedef">visit_typedef</a>(self, node):</span>
<a id="line123"></a><span class="lineno">123</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">        self.output.write(<span class="py-string">'typedef %s %s;\n'</span>%(self.typeid(node.alias), node.name[-1]))</span>
<a id="line125"></a><span class="lineno">125</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html#visit_variable">visit_variable</a>(self, variable):</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">        self.output.write(<span class="py-string">'%s %s;\n'</span>%(self.typeid(variable.vtype), variable.name[-1]))</span>
<a id="line128"></a><span class="lineno">128</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html#visit_const">visit_const</a>(self, const):</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">        self.output.write(<span class="py-string">'%s %s;\n'</span>%(self.typeid(const.ctype), const.name[-1]))</span>
<a id="line131"></a><span class="lineno">131</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html#visit_builtin_type_id">visit_builtin_type_id</a>(self, type): self._typeid = type.name[-1]</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html#visit_unknown_type_id">visit_unknown_type_id</a>(self, type): self._typeid = escape(str(type.name))</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html#visit_declared_type_id">visit_declared_type_id</a>(self, type): self._typeid = escape(str(type.name))</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html#visit_modifier_type_id">visit_modifier_type_id</a>(self, type):</span>
<a id="line136"></a><span class="lineno">136</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">        self._typeid = <span class="py-string">'%s %s %s'</span>%(escape(<span class="py-string">' '</span>.join(type.premod)),</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">                                   self.typeid(type.alias),</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">                                   escape(<span class="py-string">' '</span>.join(type.postmod)))</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html#visit_array_type_id">visit_array_type_id</a>(self, type):</span>
<a id="line141"></a><span class="lineno">141</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">        self._typeid = <span class="py-string">'%s%s'</span>%(escape(str(type.name)), <span class="py-string">''</span>.join([<span class="py-string">'[%s]'</span>%s <span class="py-keyword">for</span> s <span class="py-keyword">in</span> type.sizes]))</span>
<a id="line143"></a><span class="lineno">143</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html#visit_template_id">visit_template_id</a>(self, type): self._typeid = escape(str(type.name))</span>
<a id="line145"></a><span class="lineno">145</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html#visit_parametrized_type_id">visit_parametrized_type_id</a>(self, type):</span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">        self._typeid = <span class="py-string">'%s&amp;lt;%s&amp;gt;'</span>%(self.typeid(type.template),</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">                                       <span class="py-string">', '</span>.join([self.typeid(p) <span class="py-keyword">for</span> p <span class="py-keyword">in</span> type.parameters]))</span>
<a id="line150"></a><span class="lineno">150</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html#visit_function_type_id">visit_function_type_id</a>(self, type):</span>
<a id="line152"></a><span class="lineno">152</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">        self._typeid = <span class="py-string">'%s(%s)'</span>%(self.typeid(type.return_type),</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">                                 <span class="py-string">', '</span>.join([self.typeid(p) <span class="py-keyword">for</span> p <span class="py-keyword">in</span> type.parameters]))</span>
<a id="line155"></a><span class="lineno">155</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSyntax.html#visit_dependent_type_id">visit_dependent_type_id</a>(self, type): self._typeid = type.name[-1]</span>
<a id="line157"></a><span class="lineno">157</span>
<a id="line158"></a><span class="lineno">158</span>
<a id="line159"></a><span class="lineno">159</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSummarySyntax.html">CxxSummarySyntax</a>(CxxSyntax):</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Generate DocBook Synopsis for C++ declarations.&quot;&quot;&quot;</span></span>
<a id="line161"></a><span class="lineno">161</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSummarySyntax.html#__init__">__init__</a>(self, output):</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">        super(CxxSummarySyntax, self).__init__(output)</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">        self.output.write(<span class="py-string">'&lt;synopsis&gt;'</span>)</span>
<a id="line165"></a><span class="lineno">165</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSummarySyntax.html#finish">finish</a>(self):</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">        self.output.write(<span class="py-string">'&lt;/synopsis&gt;\n'</span>)</span>
<a id="line168"></a><span class="lineno">168</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSummarySyntax.html#visit_macro">visit_macro</a>(self, macro):</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">        self.output.write(macro.name[-1])</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">        <span class="py-keyword">if</span> macro.parameters:</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">            self.output.write(<span class="py-string">'(%)'</span>%(<span class="py-string">', '</span>.join([p <span class="py-keyword">for</span> p <span class="py-keyword">in</span> macro.parameters])))</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">        self.output.write(<span class="py-string">'\n'</span>)</span>
<a id="line174"></a><span class="lineno">174</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSummarySyntax.html#visit_forward">visit_forward</a>(self, node): <span class="py-keyword">pass</span></span>
<a id="line176"></a><span class="lineno">176</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSummarySyntax.html#visit_group">visit_group</a>(self, node):</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> node.declarations:</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">            d.accept(self)</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSummarySyntax.html#visit_module">visit_module</a>(self, module):</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">        self.output.write(<span class="py-string">'%s %s;\n'</span>%(module.type, module.name[-1]))</span>
<a id="line181"></a><span class="lineno">181</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSummarySyntax.html#visit_class">visit_class</a>(self, class_):</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">        self.output.write(<span class="py-string">'%s %s;\n'</span>%(class_.type, escape(class_.name[-1])))</span>
<a id="line184"></a><span class="lineno">184</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSummarySyntax.html#visit_class_template">visit_class_template</a>(self, class_): self.visit_class(class_)</span>
<a id="line186"></a><span class="lineno">186</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSummarySyntax.html#visit_enumerator">visit_enumerator</a>(self, node):</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">        <span class="py-keyword">if</span> node.value:</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">            <span class="py-keyword">return</span> <span class="py-string">'%s=%s'</span>%(node.name[-1], escape(node.value))</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">            <span class="py-keyword">return</span> node.name[-1]</span>
<a id="line192"></a><span class="lineno">192</span>
<a id="line193"></a><span class="lineno">193</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSummarySyntax.html#visit_enum">visit_enum</a>(self, node):</span>
<a id="line194"></a><span class="lineno">194</span><span class="line">        self.output.write(<span class="py-string">'%s %s { '</span>%(node.type, node.name[-1]))</span>
<a id="line195"></a><span class="lineno">195</span><span class="line">        self.output.write(<span class="py-string">', '</span>.join([self.visit_enumerator(e)</span>
<a id="line196"></a><span class="lineno">196</span><span class="line">                                     <span class="py-keyword">for</span> e <span class="py-keyword">in</span> node.enumerators</span>
<a id="line197"></a><span class="lineno">197</span><span class="line">                                     <span class="py-keyword">if</span> isinstance(e, ASG.Enumerator)]))</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">        self.output.write(<span class="py-string">'};\n'</span>)</span>
<a id="line199"></a><span class="lineno">199</span>
<a id="line200"></a><span class="lineno">200</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxSummarySyntax.html#visit_inheritance">visit_inheritance</a>(self, node): <span class="py-keyword">pass</span></span>
<a id="line201"></a><span class="lineno">201</span>
<a id="line202"></a><span class="lineno">202</span>
<a id="line203"></a><span class="lineno">203</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxDetailSyntax.html">CxxDetailSyntax</a>(CxxSyntax):</span>
<a id="line204"></a><span class="lineno">204</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Generate DocBook Synopsis for C++ declarations.&quot;&quot;&quot;</span></span>
<a id="line205"></a><span class="lineno">205</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxDetailSyntax.html#__init__">__init__</a>(self, output):</span>
<a id="line207"></a><span class="lineno">207</span><span class="line">        super(CxxDetailSyntax, self).__init__(output)</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">        self.output.write(<span class="py-string">'&lt;synopsis&gt;'</span>)</span>
<a id="line209"></a><span class="lineno">209</span>
<a id="line210"></a><span class="lineno">210</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxDetailSyntax.html#finish">finish</a>(self):</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">        self.output.write(<span class="py-string">'&lt;/synopsis&gt;\n'</span>)</span>
<a id="line212"></a><span class="lineno">212</span>
<a id="line213"></a><span class="lineno">213</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxDetailSyntax.html#visit_macro">visit_macro</a>(self, macro):</span>
<a id="line214"></a><span class="lineno">214</span><span class="line">        self.output.write(macro.name[-1])</span>
<a id="line215"></a><span class="lineno">215</span><span class="line">        <span class="py-keyword">if</span> macro.parameters:</span>
<a id="line216"></a><span class="lineno">216</span><span class="line">            self.output.write(<span class="py-string">'(%s)'</span>%(<span class="py-string">', '</span>.join([p <span class="py-keyword">for</span> p <span class="py-keyword">in</span> macro.parameters])))</span>
<a id="line217"></a><span class="lineno">217</span><span class="line">        self.output.write(<span class="py-string">'\n'</span>)</span>
<a id="line218"></a><span class="lineno">218</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxDetailSyntax.html#visit_forward">visit_forward</a>(self, node): <span class="py-keyword">pass</span></span>
<a id="line220"></a><span class="lineno">220</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxDetailSyntax.html#visit_group">visit_group</a>(self, node):</span>
<a id="line221"></a><span class="lineno">221</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> node.declarations:</span>
<a id="line222"></a><span class="lineno">222</span><span class="line">            d.accept(self)</span>
<a id="line223"></a><span class="lineno">223</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxDetailSyntax.html#visit_module">visit_module</a>(self, module):</span>
<a id="line224"></a><span class="lineno">224</span><span class="line">        self.output.write(<span class="py-string">'%s %s;\n'</span>%(module.type, module.name[-1]))</span>
<a id="line225"></a><span class="lineno">225</span>
<a id="line226"></a><span class="lineno">226</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxDetailSyntax.html#visit_class">visit_class</a>(self, class_):</span>
<a id="line227"></a><span class="lineno">227</span><span class="line">        self.output.write(<span class="py-string">'%s %s;\n'</span>%(class_.type, escape(class_.name[-1])))</span>
<a id="line228"></a><span class="lineno">228</span>
<a id="line229"></a><span class="lineno">229</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxDetailSyntax.html#visit_class_template">visit_class_template</a>(self, node): <span class="py-keyword">pass</span></span>
<a id="line230"></a><span class="lineno">230</span>
<a id="line231"></a><span class="lineno">231</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxDetailSyntax.html#visit_enumerator">visit_enumerator</a>(self, node):</span>
<a id="line232"></a><span class="lineno">232</span><span class="line">        <span class="py-keyword">if</span> node.value:</span>
<a id="line233"></a><span class="lineno">233</span><span class="line">            <span class="py-keyword">return</span> <span class="py-string">'%s=%s'</span>%(node.name[-1], escape(node.value))</span>
<a id="line234"></a><span class="lineno">234</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line235"></a><span class="lineno">235</span><span class="line">            <span class="py-keyword">return</span> node.name[-1]</span>
<a id="line236"></a><span class="lineno">236</span>
<a id="line237"></a><span class="lineno">237</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxDetailSyntax.html#visit_enum">visit_enum</a>(self, node):</span>
<a id="line238"></a><span class="lineno">238</span><span class="line">        self.output.write(<span class="py-string">'%s %s { '</span>%(node.type, node.name[-1]))</span>
<a id="line239"></a><span class="lineno">239</span><span class="line">        self.output.write(<span class="py-string">', '</span>.join([self.visit_enumerator(e)</span>
<a id="line240"></a><span class="lineno">240</span><span class="line">                                     <span class="py-keyword">for</span> e <span class="py-keyword">in</span> node.enumerators</span>
<a id="line241"></a><span class="lineno">241</span><span class="line">                                     <span class="py-keyword">if</span> isinstance(e, ASG.Enumerator)]))</span>
<a id="line242"></a><span class="lineno">242</span><span class="line">        self.output.write(<span class="py-string">'};\n'</span>)</span>
<a id="line243"></a><span class="lineno">243</span>
<a id="line244"></a><span class="lineno">244</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Formatters/DocBook/Syntax/CxxDetailSyntax.html#visit_inheritance">visit_inheritance</a>(self, node): <span class="py-keyword">pass</span></span>
<a id="line245"></a><span class="lineno">245</span>
<a id="line246"></a><span class="lineno">246</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:13 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
